drop table if exists snb_delivery.niksm_fct_delivery;
create table snb_delivery.niksm_fct_delivery
(
	corp_client_id varchar,
	corp_contract_id varchar,
	tariff_zone varchar,
	order_id varchar,
	tariff_class_code varchar,
	source_address text,
	destination_address text,
	currency_code varchar,
	deliveries_plan_cnt bigint,
	deliveries_cnt bigint,
	gmv numeric,
	net_inflow numeric,
	claims_per_order bigint,
	utc_created_dttm timestamp,
	msk_created_dt date,
	logging_flg boolean,
	utc_accepted_dttm timestamp,
	utc_found_dttm timestamp,
	utc_a_arrived_dttm timestamp,
	utc_a_visited_dttm timestamp,
	utc_b_visited_last_dttm timestamp,
	utc_cancelled_dttm timestamp,
	utc_due_dttm timestamp,
	cargo_flg boolean,
	taxi_flg boolean,
	corp_flg boolean,
	k2_lavka_flg boolean,
	claim_id bigint,
	cargo_ref_id varchar,
	claim_status_code varchar,
	claim_accepted_flg boolean,
	taxi_user_status varchar,
	taxi_driver_status varchar,
	success_order_flg boolean,
	order_source_code varchar,
	order_type varchar,
	cargo_utc_created_dttm timestamp,
	taxi_utc_order_created_dttm timestamp,
	cargo_utc_due_dttm timestamp,
	taxi_utc_order_due_dttm timestamp
)
distributed by (claim_id, order_id)
 partition by range (utc_created_dttm) (
    partition "201901" start ('2019-01-01 00:00:00'::timestamp without time zone) end ('2019-02-01 00:00:00'::timestamp without time zone),
    partition "201902" start ('2019-02-01 00:00:00'::timestamp without time zone) end ('2019-03-01 00:00:00'::timestamp without time zone),
    partition "201903" start ('2019-03-01 00:00:00'::timestamp without time zone) end ('2019-04-01 00:00:00'::timestamp without time zone),
    partition "201904" start ('2019-04-01 00:00:00'::timestamp without time zone) end ('2019-05-01 00:00:00'::timestamp without time zone),
    partition "201905" start ('2019-05-01 00:00:00'::timestamp without time zone) end ('2019-06-01 00:00:00'::timestamp without time zone),
    partition "201906" start ('2019-06-01 00:00:00'::timestamp without time zone) end ('2019-07-01 00:00:00'::timestamp without time zone),
    partition "201907" start ('2019-07-01 00:00:00'::timestamp without time zone) end ('2019-08-01 00:00:00'::timestamp without time zone),
    partition "201908" start ('2019-08-01 00:00:00'::timestamp without time zone) end ('2019-09-01 00:00:00'::timestamp without time zone),
    partition "201909" start ('2019-09-01 00:00:00'::timestamp without time zone) end ('2019-10-01 00:00:00'::timestamp without time zone),
    partition "201910" start ('2019-10-01 00:00:00'::timestamp without time zone) end ('2019-11-01 00:00:00'::timestamp without time zone),
    partition "201911" start ('2019-11-01 00:00:00'::timestamp without time zone) end ('2019-12-01 00:00:00'::timestamp without time zone),
    partition "201912" start ('2019-12-01 00:00:00'::timestamp without time zone) end ('2020-01-01 00:00:00'::timestamp without time zone),
    partition "202001" start ('2020-01-01 00:00:00'::timestamp without time zone) end ('2020-02-01 00:00:00'::timestamp without time zone),
    partition "202002" start ('2020-02-01 00:00:00'::timestamp without time zone) end ('2020-03-01 00:00:00'::timestamp without time zone),
    partition "202003" start ('2020-03-01 00:00:00'::timestamp without time zone) end ('2020-04-01 00:00:00'::timestamp without time zone),
    partition "202004" start ('2020-04-01 00:00:00'::timestamp without time zone) end ('2020-05-01 00:00:00'::timestamp without time zone),
    partition "202005" start ('2020-05-01 00:00:00'::timestamp without time zone) end ('2020-06-01 00:00:00'::timestamp without time zone),
    partition "202006" start ('2020-06-01 00:00:00'::timestamp without time zone) end ('2020-07-01 00:00:00'::timestamp without time zone),
    partition "202007" start ('2020-07-01 00:00:00'::timestamp without time zone) end ('2020-08-01 00:00:00'::timestamp without time zone),
    partition "202008" start ('2020-08-01 00:00:00'::timestamp without time zone) end ('2020-09-01 00:00:00'::timestamp without time zone),
    partition "202009" start ('2020-09-01 00:00:00'::timestamp without time zone) end ('2020-10-01 00:00:00'::timestamp without time zone),
    partition "202010" start ('2020-10-01 00:00:00'::timestamp without time zone) end ('2020-11-01 00:00:00'::timestamp without time zone),
    partition "202011" start ('2020-11-01 00:00:00'::timestamp without time zone) end ('2020-12-01 00:00:00'::timestamp without time zone),
    partition "202012" start ('2020-12-01 00:00:00'::timestamp without time zone) end ('2021-01-01 00:00:00'::timestamp without time zone),
    partition "202101" start ('2021-01-01 00:00:00'::timestamp without time zone) end ('2021-02-01 00:00:00'::timestamp without time zone),
    partition "202102" start ('2021-02-01 00:00:00'::timestamp without time zone) end ('2021-03-01 00:00:00'::timestamp without time zone),
    partition "202103" start ('2021-03-01 00:00:00'::timestamp without time zone) end ('2021-04-01 00:00:00'::timestamp without time zone),
    partition "202104" start ('2021-04-01 00:00:00'::timestamp without time zone) end ('2021-05-01 00:00:00'::timestamp without time zone),
    partition "202105" start ('2021-05-01 00:00:00'::timestamp without time zone) end ('2021-06-01 00:00:00'::timestamp without time zone),
    partition "202106" start ('2021-06-01 00:00:00'::timestamp without time zone) end ('2021-07-01 00:00:00'::timestamp without time zone),
    partition "202107" start ('2021-07-01 00:00:00'::timestamp without time zone) end ('2021-08-01 00:00:00'::timestamp without time zone),
    partition "202108" start ('2021-08-01 00:00:00'::timestamp without time zone) end ('2021-09-01 00:00:00'::timestamp without time zone),
    partition "202109" start ('2021-09-01 00:00:00'::timestamp without time zone) end ('2021-10-01 00:00:00'::timestamp without time zone),
    partition "202110" start ('2021-10-01 00:00:00'::timestamp without time zone) end ('2021-11-01 00:00:00'::timestamp without time zone),
    partition "202111" start ('2021-11-01 00:00:00'::timestamp without time zone) end ('2021-12-01 00:00:00'::timestamp without time zone),
    partition "202112" start ('2021-12-01 00:00:00'::timestamp without time zone) end ('2022-01-01 00:00:00'::timestamp without time zone),
    partition "202201" start ('2022-01-01 00:00:00'::timestamp without time zone) end ('2022-02-01 00:00:00'::timestamp without time zone),
    partition "202202" start ('2022-02-01 00:00:00'::timestamp without time zone) end ('2022-03-01 00:00:00'::timestamp without time zone),
    partition "202203" start ('2022-03-01 00:00:00'::timestamp without time zone) end ('2022-04-01 00:00:00'::timestamp without time zone),
    partition "202204" start ('2022-04-01 00:00:00'::timestamp without time zone) end ('2022-05-01 00:00:00'::timestamp without time zone),
    partition "202205" start ('2022-05-01 00:00:00'::timestamp without time zone) end ('2022-06-01 00:00:00'::timestamp without time zone),
    partition "202206" start ('2022-06-01 00:00:00'::timestamp without time zone) end ('2022-07-01 00:00:00'::timestamp without time zone),
    partition "202207" start ('2022-07-01 00:00:00'::timestamp without time zone) end ('2022-08-01 00:00:00'::timestamp without time zone),
    partition "202208" start ('2022-08-01 00:00:00'::timestamp without time zone) end ('2022-09-01 00:00:00'::timestamp without time zone),
    partition "202209" start ('2022-09-01 00:00:00'::timestamp without time zone) end ('2022-10-01 00:00:00'::timestamp without time zone),
    partition "202210" start ('2022-10-01 00:00:00'::timestamp without time zone) end ('2022-11-01 00:00:00'::timestamp without time zone),
    partition "202211" start ('2022-11-01 00:00:00'::timestamp without time zone) end ('2022-12-01 00:00:00'::timestamp without time zone),
    partition "202212" start ('2022-12-01 00:00:00'::timestamp without time zone) end ('2023-01-01 00:00:00'::timestamp without time zone),
    partition "202301" start ('2023-01-01 00:00:00'::timestamp without time zone) end ('2023-02-01 00:00:00'::timestamp without time zone),
    partition "202302" start ('2023-02-01 00:00:00'::timestamp without time zone) end ('2023-03-01 00:00:00'::timestamp without time zone),
    partition "202303" start ('2023-03-01 00:00:00'::timestamp without time zone) end ('2023-04-01 00:00:00'::timestamp without time zone),
    partition "202304" start ('2023-04-01 00:00:00'::timestamp without time zone) end ('2023-05-01 00:00:00'::timestamp without time zone),
    partition "202305" start ('2023-05-01 00:00:00'::timestamp without time zone) end ('2023-06-01 00:00:00'::timestamp without time zone),
    partition "202306" start ('2023-06-01 00:00:00'::timestamp without time zone) end ('2023-07-01 00:00:00'::timestamp without time zone),
    partition "202307" start ('2023-07-01 00:00:00'::timestamp without time zone) end ('2023-08-01 00:00:00'::timestamp without time zone),
    partition "202308" start ('2023-08-01 00:00:00'::timestamp without time zone) end ('2023-09-01 00:00:00'::timestamp without time zone),
    partition "202309" start ('2023-09-01 00:00:00'::timestamp without time zone) end ('2023-10-01 00:00:00'::timestamp without time zone),
    partition "202310" start ('2023-10-01 00:00:00'::timestamp without time zone) end ('2023-11-01 00:00:00'::timestamp without time zone),
    partition "202311" start ('2023-11-01 00:00:00'::timestamp without time zone) end ('2023-12-01 00:00:00'::timestamp without time zone),
    partition "202312" start ('2023-12-01 00:00:00'::timestamp without time zone) end ('2024-01-01 00:00:00'::timestamp without time zone),
    partition "202401" start ('2024-01-01 00:00:00'::timestamp without time zone) end ('2024-02-01 00:00:00'::timestamp without time zone),
    partition "202402" start ('2024-02-01 00:00:00'::timestamp without time zone) end ('2024-03-01 00:00:00'::timestamp without time zone),
    partition "202403" start ('2024-03-01 00:00:00'::timestamp without time zone) end ('2024-04-01 00:00:00'::timestamp without time zone),
    partition "202404" start ('2024-04-01 00:00:00'::timestamp without time zone) end ('2024-05-01 00:00:00'::timestamp without time zone),
    partition "202405" start ('2024-05-01 00:00:00'::timestamp without time zone) end ('2024-06-01 00:00:00'::timestamp without time zone),
    partition "202406" start ('2024-06-01 00:00:00'::timestamp without time zone) end ('2024-07-01 00:00:00'::timestamp without time zone),
    partition "202407" start ('2024-07-01 00:00:00'::timestamp without time zone) end ('2024-08-01 00:00:00'::timestamp without time zone),
    partition "202408" start ('2024-08-01 00:00:00'::timestamp without time zone) end ('2024-09-01 00:00:00'::timestamp without time zone),
    partition "202409" start ('2024-09-01 00:00:00'::timestamp without time zone) end ('2024-10-01 00:00:00'::timestamp without time zone),
    partition "202410" start ('2024-10-01 00:00:00'::timestamp without time zone) end ('2024-11-01 00:00:00'::timestamp without time zone),
    partition "202411" start ('2024-11-01 00:00:00'::timestamp without time zone) end ('2024-12-01 00:00:00'::timestamp without time zone),
    partition "202412" start ('2024-12-01 00:00:00'::timestamp without time zone) end ('2025-01-01 00:00:00'::timestamp without time zone),
    partition "202501" start ('2025-01-01 00:00:00'::timestamp without time zone) end ('2025-02-01 00:00:00'::timestamp without time zone),
    partition "202502" start ('2025-02-01 00:00:00'::timestamp without time zone) end ('2025-03-01 00:00:00'::timestamp without time zone),
    partition "202503" start ('2025-03-01 00:00:00'::timestamp without time zone) end ('2025-04-01 00:00:00'::timestamp without time zone),
    partition "202504" start ('2025-04-01 00:00:00'::timestamp without time zone) end ('2025-05-01 00:00:00'::timestamp without time zone),
    partition "202505" start ('2025-05-01 00:00:00'::timestamp without time zone) end ('2025-06-01 00:00:00'::timestamp without time zone),
    partition "202506" start ('2025-06-01 00:00:00'::timestamp without time zone) end ('2025-07-01 00:00:00'::timestamp without time zone),
    partition "202507" start ('2025-07-01 00:00:00'::timestamp without time zone) end ('2025-08-01 00:00:00'::timestamp without time zone),
    partition "202508" start ('2025-08-01 00:00:00'::timestamp without time zone) end ('2025-09-01 00:00:00'::timestamp without time zone),
    partition "202509" start ('2025-09-01 00:00:00'::timestamp without time zone) end ('2025-10-01 00:00:00'::timestamp without time zone),
    partition "202510" start ('2025-10-01 00:00:00'::timestamp without time zone) end ('2025-11-01 00:00:00'::timestamp without time zone),
    partition "202511" start ('2025-11-01 00:00:00'::timestamp without time zone) end ('2025-12-01 00:00:00'::timestamp without time zone),
    partition "202512" start ('2025-12-01 00:00:00'::timestamp without time zone) end ('2026-01-01 00:00:00'::timestamp without time zone));

comment on table snb_delivery.niksm_fct_delivery is 'Витрина по доставкам, claims full join orders';
