insert into snb_b2b.niksm_b2b_process_log (process_name, event_name, event_timestamp) VALUES ('amo_lk_clients_info', 'Start', clock_timestamp());

drop table if exists res;
create temporary table res as
select lk.corp_client_id, lk.billing_client_id, lk.corp_client_name,
       lk.service_active_flg_dict, lk.service_test_flg_dict, lk.service_visible_flg_dict, lk.next_day_delivery_flg,
       lk.trial_flg, lk.utc_client_created_dttm, lk.utc_client_updated_dttm, lk.country_code, lk.yandex_login,
       lk.cargo_service_active_flg, lk.taxi_service_active_flg,
       lk.corp_contract_id, lk.billing_contract_id, lk.currency_code,
       lk.billing_contract_active_flg, lk.billing_contract_cancelled_flg, lk.offer_flg, lk.offer_accepted_flg,
       lk.payment_term_dur, lk.payment_type, lk.quasi_postpayment_type, lk.quasi_threshold_ccy_value,
       lk.service_ids_text, lk.billing_contract_signed_flg, lk.billing_contract_suspended_flg,
       lk.utc_contract_finish_dttm, lk.utc_contract_start_dttm, lk.utc_contract_created_dttm, lk.utc_contract_updated_dttm,
       lk.edo_offer_accepted_flg, lk.activate_flg, lk.auto_activate_flg,
       lk.contract_limit_ccy_value, lk.contract_limit_threshold_ccy_value,
       lk.low_balance_notification_flg, lk.low_balance_threshold_ccy_value,
       case
           when crm_contract.contract_id is not null
               then crm_contract.crm_source
           else crm_client.crm_source end                 as crm_source,
       case
           when crm_contract.contract_id is not null
               then crm_contract.lead_id
           else crm_client.lead_id end                    as lead_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.lead_name
           when crm_client.corp_client_id is not null
               then crm_client.lead_name
           else crm_int.deal_title end                    as lead_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.price
           when crm_client.corp_client_id is not null
               then crm_client.price
           else crm_int.potential end                     as price,
       case
           when crm_contract.contract_id is not null
               then crm_contract.score
           else crm_client.score end                      as score,
       case
           when crm_contract.contract_id is not null
               then crm_contract.group_id
           else crm_client.group_id end                   as group_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.tags
           else crm_client.tags end                       as tags,
       case
           when crm_contract.contract_id is not null
               then crm_contract.company_id
           else crm_client.company_id end                 as company_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.closed_at
           else crm_client.closed_at end                  as closed_at,
       case
           when crm_contract.contract_id is not null
               then crm_contract.account_id
           else crm_client.account_id end                 as account_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.utc_lead_created_dttm
           else crm_client.utc_lead_created_dttm end      as utc_lead_created_dttm,
       case
           when crm_contract.contract_id is not null
               then crm_contract.created_by
           else crm_client.created_by end                 as created_by,
       case
           when crm_contract.contract_id is not null
               then crm_contract.lead_deleted_flg
           else crm_client.lead_deleted_flg end           as lead_deleted_flg,
       case
           when crm_contract.contract_id is not null
               then crm_contract.utc_lead_updated_dttm
           else crm_client.utc_lead_updated_dttm end      as utc_lead_updated_dttm,
       case
           when crm_contract.contract_id is not null
               then crm_contract.updated_by
           else crm_client.updated_by end                 as updated_by,
       case
           when crm_contract.contract_id is not null
               then crm_contract.pipeline_id
           else crm_client.pipeline_id end                as pipeline_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.pipeline_name
           else crm_client.pipeline_name end              as pipeline_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.status_id
           else crm_client.status_id end                  as status_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.pipeline_status_name
           else crm_client.pipeline_status_name end       as pipeline_status_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.lead_status
           when crm_client.corp_client_id is not null
               then crm_client.lead_status
           else crm_int.status end                        as lead_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.loss_reason_id
           else crm_client.loss_reason_id end             as loss_reason_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.loss_reason_name
           else crm_client.loss_reason_name end           as loss_reason_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.utc_closest_task_dttm
           else crm_client.utc_closest_task_dttm end      as utc_closest_task_dttm,
       case
           when crm_contract.contract_id is not null
               then crm_contract.responsible_user_id
           else crm_client.responsible_user_id end        as responsible_user_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.contact_id
           else crm_client.contact_id end                 as contact_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.product
           else crm_client.product end                    as product,
       case
           when crm_contract.contract_id is not null
               then crm_contract.contract_type
           else crm_client.contract_type end              as contract_type,
       case
           when crm_contract.contract_id is not null
               then crm_contract.payment_type
           else crm_client.payment_type end               as crm_payment_type,
       case
           when crm_contract.contract_id is not null
               then crm_contract.integration_status
           else crm_client.integration_status end         as integration_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.mancalc_ticket
           else crm_client.mancalc_ticket end             as mancalc_ticket,
       case
           when crm_contract.contract_id is not null
               then crm_contract.main_deal_link
           else crm_client.main_deal_link end             as main_deal_link,
       case
           when crm_contract.contract_id is not null
               then crm_contract.channel
           else crm_client.channel end                    as channel,
       case
           when crm_contract.contract_id is not null
               then crm_contract.integration_module
           else crm_client.integration_module end         as integration_module,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_potential
           else crm_client.ndd_potential end              as ndd_potential,
--        case
--            when crm_contract.contract_id is not null
--                then crm_contract.corp_client_id
--            when crm_client.corp_client_id is not null
--                then crm_client.corp_client_id
--            else crm_int.corp_client_id end                as corp_client_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.yado_store_id
           else crm_client.yado_store_id end              as yado_store_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.yado_client_id
           else crm_client.yado_client_id end             as yado_client_id,
--        case
--            when crm_contract.contract_id is not null
--                then crm_contract.contract_id
--            when crm_client.corp_client_id is not null
--                then crm_client.contract_id
--            else crm_int.contract_id end                   as contract_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_integration_status
           else crm_client.ndd_integration_status end     as ndd_integration_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.information_system
           else crm_client.information_system end         as information_system,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_pipeline_stage
           else crm_client.ndd_pipeline_stage end         as ndd_pipeline_stage,
       case
           when crm_contract.contract_id is not null
               then crm_contract.pd_deal_id
           else crm_client.pd_deal_id end                 as pd_deal_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.wishlist
           else crm_client.wishlist end                   as wishlist,
       case
           when crm_contract.contract_id is not null
               then crm_contract.scorer
           else crm_client.scorer end                     as scorer,
       case
           when crm_contract.contract_id is not null
               then crm_contract.company_name
           else crm_client.company_name end               as company_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.utc_company_created_dttm
           else crm_client.utc_company_created_dttm end   as utc_company_created_dttm,
       case
           when crm_contract.contract_id is not null
               then crm_contract.company_deleted_flg
           else crm_client.company_deleted_flg end        as company_deleted_flg,
       case
           when crm_contract.contract_id is not null
               then crm_contract.website
           else crm_client.website end                    as website,
       case
           when crm_contract.contract_id is not null
               then crm_contract.tier
           when crm_client.corp_client_id is not null
               then crm_client.tier
           else crm_int.tier end                          as tier,
       case
           when crm_contract.contract_id is not null
               then crm_contract.country
           when crm_client.corp_client_id is not null
               then crm_client.country
           else crm_int.country end                       as country,
       case
           when crm_contract.contract_id is not null
               then crm_contract.magistral_id
           else crm_client.magistral_id end               as magistral_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.inn
           else crm_client.inn end                        as inn,
       case
           when crm_contract.contract_id is not null
               then crm_contract.kpp
           else crm_client.kpp end                        as kpp,
       case
           when crm_contract.contract_id is not null
               then crm_contract.market_segment
           when crm_client.corp_client_id is not null
               then crm_client.market_segment
           else crm_int.market_segment end                as market_segment,
       case
           when crm_contract.contract_id is not null
               then crm_contract.credit_rating
           else crm_client.credit_rating end              as credit_rating,
       case
           when crm_contract.contract_id is not null
               then crm_contract.company_group_type
           else crm_client.company_group_type end         as company_group_type,
       case
           when crm_contract.contract_id is not null
               then crm_contract.marketing_status
           else crm_client.marketing_status end           as marketing_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.city
           else crm_client.city end                       as city,
       case
           when crm_contract.contract_id is not null
               then crm_contract.holding_id
           else crm_client.holding_id end                 as holding_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.holding_name
           when crm_client.corp_client_id is not null
               then crm_client.holding_name
           else crm_int.holding_name end                  as holding_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.geography
           else crm_client.geography end                  as geography,
       case
           when crm_contract.contract_id is not null
               then crm_contract.pd_org_id
           else crm_client.pd_org_id end                  as pd_org_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_lang
           else crm_client.user_lang end                  as user_lang,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_name
           else crm_client.user_name end                  as user_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_email
           else crm_client.user_email end                 as user_email,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_login
           when crm_client.corp_client_id is not null
               then crm_client.manager_login
           else crm_int.manager_login end                 as manager_login,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_name
           when crm_client.corp_client_id is not null
               then crm_client.manager_name
           else crm_int.manager_name end                  as manager_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_name_first
           else crm_client.manager_name_first end         as manager_name_first,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_name_last
           else crm_client.manager_name_last end          as manager_name_last,
       case
           when crm_contract.contract_id is not null
               then crm_contract.teamlead_name
           when crm_client.corp_client_id is not null
               then crm_client.teamlead_name
           else crm_int.lead_name end                     as teamlead_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.teamlead_name_first
           else crm_client.teamlead_name_first end        as teamlead_name_first,
       case
           when crm_contract.contract_id is not null
               then crm_contract.teamlead_name_last
           else crm_client.teamlead_name_last end         as teamlead_name_last,
       case
           when crm_contract.contract_id is not null
               then crm_contract.department_name
           when crm_client.corp_client_id is not null
               then crm_client.department_name
           else crm_int.department_name end               as department_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_group
           when crm_client.corp_client_id is not null
               then crm_client.manager_group
           else crm_int.manager_group end                 as manager_group,
       case
           when crm_contract.contract_id is not null
               then crm_contract.permissions
           when crm_client.corp_client_id is not null
               then crm_client.permissions
           else crm_int.permissions end                   as permissions,
       case
           when crm_contract.contract_id is not null
               then crm_contract.external_event_id
           else crm_client.external_event_id end          as external_event_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.phoenix_flg
           else crm_client.phoenix_flg end                as phoenix_flg,
       case
           when crm_contract.contract_id is not null
               then crm_contract.contract_terminated_flg
           else crm_client.contract_terminated_flg end    as contract_terminated_flg,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_group_id
           else crm_client.user_group_id end              as user_group_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_group_name
           else crm_client.user_group_name end            as user_group_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_role_id
           else crm_client.user_role_id end               as user_role_id,
       case
           when crm_contract.contract_id is not null
               then crm_contract.user_role_name
           else crm_client.user_role_name end             as user_role_name,
       case
           when crm_contract.contract_id is not null
               then crm_contract.add_contract_flg
           else crm_client.add_contract_flg end           as add_contract_flg,
       case
           when crm_contract.contract_id is not null
               then crm_contract.bd_reason
           else crm_client.bd_reason end                  as bd_reason,
       case
           when crm_contract.contract_id is not null
               then crm_contract.risk_repay_ovr_debt
           else crm_client.risk_repay_ovr_debt end        as risk_repay_ovr_debt,
       case
           when crm_contract.contract_id is not null
               then crm_contract.debt
           else crm_client.debt end                       as debt,
       case
           when crm_contract.contract_id is not null
               then crm_contract.risk_downside_2022
           else crm_client.risk_downside_2022 end         as risk_downside_2022,
       case
           when crm_contract.contract_id is not null
               then crm_contract.risk_debt_2022
           else crm_client.risk_debt_2022 end             as risk_debt_2022,
       case
           when crm_contract.contract_id is not null
               then crm_contract.debt_working
           else crm_client.debt_working end               as debt_working,
       case
           when crm_contract.contract_id is not null
               then crm_contract.manager_metagroup
           else crm_client.manager_metagroup end          as manager_metagroup,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_integration_status
           else crm_client.sdd_integration_status end     as sdd_integration_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_pipeline_stage
           else crm_client.sdd_pipeline_stage end         as sdd_pipeline_stage,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_potential
           else crm_client.sdd_potential end              as sdd_potential,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_connected_options
           else crm_client.ndd_connected_options end      as ndd_connected_options,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_reason_loss
           else crm_client.ndd_reason_loss end            as ndd_reason_loss,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_dynamics
           else crm_client.ndd_dynamics end               as ndd_dynamics,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_reason_churn
           else crm_client.ndd_reason_churn end           as ndd_reason_churn,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_wishlist
           else crm_client.ndd_wishlist end               as ndd_wishlist,
       case
           when crm_contract.contract_id is not null
               then crm_contract.ndd_ticket_logistariff
           else crm_client.ndd_ticket_logistariff end     as ndd_ticket_logistariff,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_connected_options
           else crm_client.sdd_connected_options end      as sdd_connected_options,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_reason_loss
           else crm_client.sdd_reason_loss end            as sdd_reason_loss,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_dynamics
           else crm_client.sdd_dynamics end               as sdd_dynamics,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_reason_churn
           else crm_client.sdd_reason_churn end           as sdd_reason_churn,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_wishlist
           else crm_client.sdd_wishlist end               as sdd_wishlist,
       case
           when crm_contract.contract_id is not null
               then crm_contract.sdd_ticket_logistariff
           else crm_client.sdd_ticket_logistariff end     as sdd_ticket_logistariff,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_pipeline_stage
           else crm_client.express_pipeline_stage end     as express_pipeline_stage,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_integration_status
           else crm_client.express_integration_status end as express_integration_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_connected_options
           else crm_client.express_connected_options end  as express_connected_options,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_reason_loss
           else crm_client.express_reason_loss end        as express_reason_loss,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_dynamics
           else crm_client.express_dynamics end           as express_dynamics,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_reason_churn
           else crm_client.express_reason_churn end       as express_reason_churn,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_wishlist
           else crm_client.express_wishlist end           as express_wishlist,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_ticket_logistariff
           else crm_client.express_ticket_logistariff end as express_ticket_logistariff,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_pipeline_stage
           else crm_client.cargo_pipeline_stage end       as cargo_pipeline_stage,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_integration_status
           else crm_client.cargo_integration_status end   as cargo_integration_status,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_connected_options
           else crm_client.cargo_connected_options end    as cargo_connected_options,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_reason_loss
           else crm_client.cargo_reason_loss end          as cargo_reason_loss,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_dynamics
           else crm_client.cargo_dynamics end             as cargo_dynamics,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_reason_churn
           else crm_client.cargo_reason_churn end         as cargo_reason_churn,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_wishlist
           else crm_client.cargo_wishlist end             as cargo_wishlist,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_ticket_logistariff
           else crm_client.cargo_ticket_logistariff end   as cargo_ticket_logistariff,
       case
           when crm_contract.contract_id is not null
               then crm_contract.express_potential
           else crm_client.express_potential end          as express_potential,
       case
           when crm_contract.contract_id is not null
               then crm_contract.cargo_potential
           else crm_client.cargo_potential end            as cargo_potential,
       least(lk._etl_processed_dttm, crm_contract._etl_processed_dttm, crm_client._etl_processed_dttm)
           as _etl_processed_dttm
from snb_b2b.dbcorp_client_info lk
  left join snb_b2b.amo_contracts_info crm_contract
    on crm_contract.contract_id = lk.corp_contract_id
    and crm_contract.pipeline_name <> 'ФЕНИКС'
  left join snb_b2b.amo_clients_info crm_client
    on crm_client.corp_client_id = lk.corp_client_id
    and crm_client.pipeline_name = 'ФЕНИКС'
  left join snb_b2b.niksm_b2b_contracts_info_sf crm_int
    on crm_int.contract_id = lk.corp_contract_id;

-- drop table if exists snb_b2b.amo_lk_clients_info;
-- create table snb_b2b.amo_lk_clients_info as
truncate table snb_b2b.amo_lk_clients_info;
insert into snb_b2b.amo_lk_clients_info
    (corp_client_id, billing_client_id, corp_client_name,
       service_active_flg_dict, service_test_flg_dict, service_visible_flg_dict, next_day_delivery_flg,
       trial_flg, utc_client_created_dttm, utc_client_updated_dttm, country_code, yandex_login,
       cargo_service_active_flg, taxi_service_active_flg,
       corp_contract_id, billing_contract_id, currency_code,
       billing_contract_active_flg, billing_contract_cancelled_flg, offer_flg, offer_accepted_flg,
       payment_term_dur, payment_type, quasi_postpayment_type, quasi_threshold_ccy_value,
       service_ids_text, billing_contract_signed_flg, billing_contract_suspended_flg,
       utc_contract_finish_dttm, utc_contract_start_dttm, utc_contract_created_dttm, utc_contract_updated_dttm,
       edo_offer_accepted_flg, activate_flg, auto_activate_flg,
       contract_limit_ccy_value, contract_limit_threshold_ccy_value,
       low_balance_notification_flg, low_balance_threshold_ccy_value,
       --
       crm_source, lead_id,
       lead_name, price, score, group_id, tags, company_id, closed_at, account_id, utc_lead_created_dttm, created_by,
       lead_deleted_flg, utc_lead_updated_dttm, updated_by, pipeline_id, pipeline_name, status_id, pipeline_status_name,
       lead_status, loss_reason_id, loss_reason_name, utc_closest_task_dttm, responsible_user_id, contact_id,
       phoenix_flg, contract_terminated_flg, add_contract_flg,
       product, contract_type,
       crm_payment_type,
       integration_status, mancalc_ticket, main_deal_link, channel,
       integration_module, ndd_potential,
--        corp_client_id,
       yado_store_id, yado_client_id,
--        contract_id,
       ndd_integration_status, information_system, ndd_pipeline_stage, pd_deal_id, wishlist, scorer, external_event_id,
       bd_reason, risk_repay_ovr_debt, debt, risk_downside_2022, risk_debt_2022, debt_working,
       company_name, utc_company_created_dttm, company_deleted_flg, website, tier, country, magistral_id,
       inn, kpp, market_segment, credit_rating, company_group_type, marketing_status, city, holding_id, holding_name,
       geography, pd_org_id,
       user_lang, user_name, user_email,
       user_group_id, user_group_name, user_role_id, user_role_name,
       manager_login,
       manager_name, manager_name_first, manager_name_last, teamlead_name, teamlead_name_first, teamlead_name_last,
       department_name, manager_group, permissions,manager_metagroup,sdd_potential,sdd_pipeline_stage,sdd_integration_status,
       ndd_connected_options, ndd_reason_loss,ndd_dynamics,ndd_reason_churn,ndd_wishlist,ndd_ticket_logistariff,
       sdd_connected_options,sdd_reason_loss,sdd_dynamics,sdd_reason_churn,sdd_wishlist,sdd_ticket_logistariff,
       express_potential,  express_pipeline_stage,  express_integration_status, express_connected_options,
       express_reason_loss, express_dynamics,express_reason_churn,express_wishlist, express_ticket_logistariff,
       cargo_potential,cargo_pipeline_stage,cargo_integration_status,cargo_connected_options,
       cargo_reason_loss,cargo_dynamics,cargo_reason_churn,cargo_wishlist,cargo_ticket_logistariff,
       --
       _etl_processed_dttm)
select corp_client_id, billing_client_id, corp_client_name,
       service_active_flg_dict, service_test_flg_dict, service_visible_flg_dict, next_day_delivery_flg,
       trial_flg, utc_client_created_dttm, utc_client_updated_dttm, country_code, yandex_login,
       cargo_service_active_flg, taxi_service_active_flg,
       corp_contract_id, billing_contract_id, currency_code,
       billing_contract_active_flg, billing_contract_cancelled_flg, offer_flg, offer_accepted_flg,
       payment_term_dur, payment_type, quasi_postpayment_type, quasi_threshold_ccy_value,
       service_ids_text, billing_contract_signed_flg, billing_contract_suspended_flg,
       utc_contract_finish_dttm, utc_contract_start_dttm, utc_contract_created_dttm, utc_contract_updated_dttm,
       edo_offer_accepted_flg, activate_flg, auto_activate_flg,
       contract_limit_ccy_value, contract_limit_threshold_ccy_value,
       low_balance_notification_flg, low_balance_threshold_ccy_value,
       --
       crm_source, lead_id,
       lead_name, price, score, group_id, tags, company_id, closed_at, account_id, utc_lead_created_dttm, created_by,
       lead_deleted_flg, utc_lead_updated_dttm, updated_by, pipeline_id, pipeline_name, status_id, pipeline_status_name,
       lead_status, loss_reason_id, loss_reason_name, utc_closest_task_dttm, responsible_user_id, contact_id,
       phoenix_flg, contract_terminated_flg, add_contract_flg,
       product, contract_type,
       crm_payment_type,
       integration_status, mancalc_ticket, main_deal_link, channel,
       integration_module, ndd_potential,
--        corp_client_id,
       yado_store_id, yado_client_id,
--        contract_id,
       ndd_integration_status, information_system, ndd_pipeline_stage, pd_deal_id, wishlist, scorer, external_event_id,
       bd_reason, risk_repay_ovr_debt, debt, risk_downside_2022, risk_debt_2022, debt_working,
       company_name, utc_company_created_dttm, company_deleted_flg, website, tier, country, magistral_id,
       inn, kpp, market_segment, credit_rating, company_group_type, marketing_status, city, holding_id, holding_name,
       geography, pd_org_id,
       user_lang, user_name, user_email,
       user_group_id, user_group_name, user_role_id, user_role_name,
       manager_login,
       manager_name, manager_name_first, manager_name_last, teamlead_name, teamlead_name_first, teamlead_name_last,
       department_name, manager_group, permissions,manager_metagroup,sdd_potential,sdd_pipeline_stage,sdd_integration_status,
       ndd_connected_options, ndd_reason_loss,ndd_dynamics,ndd_reason_churn,ndd_wishlist,ndd_ticket_logistariff,
       sdd_connected_options,sdd_reason_loss,sdd_dynamics,sdd_reason_churn,sdd_wishlist,sdd_ticket_logistariff,
       express_potential,  express_pipeline_stage,  express_integration_status, express_connected_options,
       express_reason_loss, express_dynamics,express_reason_churn,express_wishlist, express_ticket_logistariff,
       cargo_potential,cargo_pipeline_stage,cargo_integration_status,cargo_connected_options,
       cargo_reason_loss,cargo_dynamics,cargo_reason_churn,cargo_wishlist,cargo_ticket_logistariff,
       --
       _etl_processed_dttm
from res
-- distributed by (corp_client_id)
;
-- alter table snb_b2b.amo_lk_clients_info add constraint amo_lk_clients_info_pk primary key (corp_client_id);
-- comment on table snb_b2b.amo_lk_clients_info is 'Атрибуты клиента из ЛК и CRM. Ключ - corp_client_id';

insert into snb_b2b.niksm_b2b_process_log (process_name, event_name, event_timestamp) VALUES ('amo_lk_clients_info', 'Finish', clock_timestamp());
