create table snb_b2b.niksm_b2b_user_permission as
select 'Full base'::text as user_group,
       unnest(
           array ['niksm','sm91189','ikhomyanin','griganton', 'ferenec','alextitov',             -- analytics
               'antonuvarov','ustinenko','dima-ryzhkov',                                            -- finance
               'sinelnikov','gaman','julby',                                                        -- commerce
               'lyadovayuliya','tsapenko','v-kats','bizhov','ek-zhukova','dvolosova',
               'nemici','fedorivashkin','demkinv','kgotvald','eninaev','mmuhachev', 'akravec',
               'nzabolotny',
               'alexeyfedotov',
               'zomb-raevskiy','zomb-taxicorp2','robot-tableau-588']
           ) as user_login
union all
select 'Israel'::text as user_group,
       unnest(
           array ['igorrebkovets','orzr1988','nik-iv','maxfedyna','weissnir']
           ) as user_login
union all
select 'International'::text as user_group,
       unnest(
           array ['mapblwka','nik-iv','kr-nikolaev','chetyrin','prokazova']
           ) as user_login
union all
select 'Telemarketing'::text as user_group,
       unnest(
           array ['lapinaviks13','anastasiia-9x','rubinstein','lengardn']
           ) as user_login
union all
select 'CRM'::text as user_group,
       unnest(
           array ['klipovka','voytekh','e-khachat','imchigrin']
           ) as user_login;

-- Insert/delete example --
insert into snb_b2b.niksm_b2b_user_permission (user_group, user_login)
values ('Full base','anayat');
-- select 'Israel'::text as user_group,
--        unnest(
--            array ['andreiyasno', 'lerafrisher', 'allanw', 'guyab', 'avi1590']
--            ) as user_login;
-- delete from snb_b2b.niksm_b2b_user_permission
-- where user_group in ('Israel');
-- select * from snb_b2b.niksm_b2b_user_permission where user_group in ('Full base');

comment on table snb_b2b.niksm_b2b_user_permission is 'Группы юзеров с исключительными правами к сделкам менеджеров Коммерции';
revoke insert, delete on snb_b2b.niksm_b2b_user_permission from rw_snb_b2b, ro_snb_b2b;
grant select, insert, delete on snb_b2b.niksm_b2b_user_permission to niksm;
