-- USE hahn;
PRAGMA yt.Pool = 'taxi-delivery';
pragma yson.DisableStrict;
PRAGMA AnsiInForEmptyOrNullableItemsCollections;

$dttm_format = DateTime::Format("%Y-%m-%d %H:%M:%S");
$dt_format = DateTime::Format("%Y-%m-%d");

INSERT INTO  `//home/taxi-delivery/analytics/dev/tsapenko/forms/quality/quality_control` WITH TRUNCATE

SELECT
id,
$dt_format(DateTime::FromSeconds(DateTime::ToSeconds(cast(created as Datetime))+cast(10800 as uint32))) as answer_dt,
$dttm_format(DateTime::FromSeconds(DateTime::ToSeconds(cast(created as Datetime))+cast(10800 as uint32))) as answer_dttm,
created,
survey_id,
yandexuid,
lang,
answer,
Yson::ConvertToInt64(answer.data.answer_boolean_597174.question.id) as answer_boolean_597174_id,
Yson::ConvertToBool(answer.data.answer_boolean_597174.value) as answer_boolean_597174,
Yson::ConvertToString(answer.data.answer_boolean_597174.value.slug) as answer_boolean_597174_key,

Yson::ConvertToInt64(answer.data.answer_choices_597153.question.id) as author_id,
Yson::ConvertToString(answer.data.answer_choices_597153.value[0].text) as author,
Yson::ConvertToString(answer.data.answer_choices_597153.value[0].key) as author_value_key,
Yson::ConvertToString(answer.data.answer_choices_597153.value[0].slug) as author_key,

Yson::ConvertToInt64(answer.data.answer_choices_597158.question.id) as operator_id,
Yson::ConvertToString(answer.data.answer_choices_597158.value[0].text) as operator,
Yson::ConvertToString(answer.data.answer_choices_597158.value[0].key) as operator_value_key,
Yson::ConvertToString(answer.data.answer_choices_597158.value[0].slug) as operator_key,

Yson::ConvertToInt64(answer.data.answer_choices_597161.question.id) as check_category_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597161.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as check_category,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597161.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as check_category_key,

Yson::ConvertToInt64(answer.data.answer_choices_597209.question.id) as checktype_id,
Yson::ConvertToString(answer.data.answer_choices_597209.value[0].text) as checktype,
Yson::ConvertToString(answer.data.answer_choices_597209.value[0].slug) as checktype_key,

Yson::ConvertToInt64(answer.data.answer_choices_597289.question.id) as tov_category_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597289.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as tov_category,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597289.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as tov_category_key,

Yson::ConvertToInt64(answer.data.answer_choices_597322.question.id) as criteriy_algorithm_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597322.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as criteriy_algorithm,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597322.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as criteriy_algorithm_key,

Yson::ConvertToInt64(answer.data.answer_date_597192.question.id) as check_dt_id,
Yson::ConvertToString(answer.data.answer_date_597192.value) as check_dt,

Yson::ConvertToInt64(answer.data.answer_url_597285.question.id) as deal_url_id,
Yson::ConvertToString(answer.data.answer_url_597285.value) as deal_url,

Yson::ConvertToInt64(answer.data.answer_choices_627412.question.id) as teamlead_id,
Yson::ConvertToString(answer.data.answer_choices_627412.value[0].text) as teamlead,
Yson::ConvertToString(answer.data.answer_choices_627412.value[0].slug) as teamlead_key,

Yson::ConvertToInt64(answer.data.answer_choices_627420.question.id) as brigadir_id,
Yson::ConvertToString(answer.data.answer_choices_627420.value[0].text) as brigadir,
Yson::ConvertToString(answer.data.answer_choices_627420.value[0].slug) as brigadir_key,

Yson::ConvertToInt64(answer.data.answer_choices_597162.question.id) as scenario_id,
Yson::ConvertToString(answer.data.answer_choices_597162.value[0].text) as scenario,
Yson::ConvertToString(answer.data.answer_choices_597162.value[0].slug) as scenario_key,

Yson::ConvertToInt64(answer.data.answer_choices_599212.question.id) as potention_id,
Yson::ConvertToString(answer.data.answer_choices_599212.value[0].col.text) as potention,
Yson::ConvertToString(answer.data.answer_choices_599212.value[0].col.key) as potention_key,

Yson::ConvertToInt64(answer.data.answer_choices_599213.question.id) as tier_id,
Yson::ConvertToString(answer.data.answer_choices_599213.value[0].col.text) as tier,
Yson::ConvertToString(answer.data.answer_choices_599213.value[0].col.key) as tier_key,
Yson::ConvertToString(answer.data.answer_choices_599213.value[1].row.text) as tier_filled,

Yson::ConvertToInt64(answer.data.answer_choices_599200.question.id) as pipeline_id,
Yson::ConvertToString(answer.data.answer_choices_599200.value[0].text) as pipeline,
Yson::ConvertToString(answer.data.answer_choices_599200.value[0].slug) as pipeline_key,

Yson::ConvertToInt64(answer.data.answer_choices_599204.question.id) as stage_id,
Yson::ConvertToString(answer.data.answer_choices_599204.value[0].text) as stage,
Yson::ConvertToString(answer.data.answer_choices_599204.value[0].slug) as stage_key,

Yson::ConvertToInt64(answer.data.answer_url_599205.question.id) as callurl_id,
Yson::ConvertToString(answer.data.answer_url_599205.value) as call_url,

Yson::ConvertToInt64(answer.data.answer_number_599209.question.id) as call_duration_id,
Yson::ConvertToString(answer.data.answer_number_599209.value[0].text) as call_duration,
Yson::ConvertToString(answer.data.answer_number_599209.value[0].slug) as call_duration_key,

Yson::ConvertToInt64(answer.data.answer_date_597194.question.id) as contact_dt_id,
Yson::ConvertToString(answer.data.answer_date_597194.value.begin) as contact_dt,
Yson::ConvertToString(answer.data.answer_date_597194.value.end) as contact_end_dt,

Yson::ConvertToInt64(answer.data.answer_choices_674009.question.id) as t_integration_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674009.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as t_integration,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674009.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as t_integration_key,

Yson::ConvertToInt64(answer.data.answer_choices_674110.question.id) as t_voice_support_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674110.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as t_voice_support,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674110.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as t_voice_support_key,

Yson::ConvertToInt64(answer.data.answer_long_text_599318.question.id) as tov_comment_id,
Yson::ConvertToString(answer.data.answer_long_text_599318.value) as tov_comment,

Yson::ConvertToInt64(answer.data.answer_files_599319.question.id) as tov_files_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_files_599319.value), ($x) -> (Yson::ConvertToString($x.path))), ';')  as tov_files,

Yson::ConvertToInt64(answer.data.answer_choices_597168.question.id) as tov_rate_id,
Yson::ConvertToString(answer.data.answer_choices_597168.value[0].col.text) as tov_rate,
Yson::ConvertToString(answer.data.answer_choices_597168.value[0].col.key) as tov_rate_key,

Yson::ConvertToInt64(answer.data.answer_choices_632085.question.id) as a_dop_contract_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_632085.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as a_dop_contract,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_632085.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as a_dop_contract_key,

Yson::ConvertToInt64(answer.data.answer_choices_634968.question.id) as a_massfix_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_634968.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as a_massfix,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_634968.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as a_massfix_key,

Yson::ConvertToInt64(answer.data.answer_choices_638010.question.id) as a_postapay_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_638010.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as a_postapay,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_638010.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as a_postapay_key,

Yson::ConvertToInt64(answer.data.answer_choices_661607.question.id) as a_scoring_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_661607.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as a_scoring,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_661607.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as a_scoring_key,

Yson::ConvertToInt64(answer.data.answer_choices_674112.question.id) as a_voice_support_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674112.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as a_voice_support,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674112.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as a_voice_support_key,

Yson::ConvertToInt64(answer.data.answer_long_text_599320.question.id) as algorithm_comment_id,
Yson::ConvertToString(answer.data.answer_long_text_599320.value) as algorithm_comment,

Yson::ConvertToInt64(answer.data.answer_files_599322.question.id) as algorithm_files_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_files_599322.value), ($x) -> (Yson::ConvertToString($x.path))), ';')  as algorithm_files,

Yson::ConvertToInt64(answer.data.answer_choices_597286.question.id) as algorithm_rate_id,
Yson::ConvertToString(answer.data.answer_choices_597286.value[0].col.text) as algorithm_rate,
Yson::ConvertToString(answer.data.answer_choices_597286.value[0].col.key) as algorithm_rate_key,

Yson::ConvertToInt64(answer.data.answer_choices_597325.question.id) as hygiene_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597325.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as hygiene,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597325.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as hygiene_key,

Yson::ConvertToInt64(answer.data.answer_choices_634970.question.id) as g_massfix_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_634970.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as g_massfix,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_634970.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as g_massfix_key,

Yson::ConvertToInt64(answer.data.answer_choices_661625.question.id) as g_scoring_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_661625.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as g_scoring,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_661625.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as g_scoring_key,

Yson::ConvertToInt64(answer.data.answer_choices_674012.question.id) as g_integration_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674012.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as g_integration,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674012.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as g_integration_key,

Yson::ConvertToInt64(answer.data.answer_choices_674113.question.id) as g_voice_support_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674113.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as g_voice_support,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_674113.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as g_voice_support_key,

Yson::ConvertToInt64(answer.data.answer_long_text_599321.question.id) as hygiene_comment_id,
Yson::ConvertToString(answer.data.answer_long_text_599321.value) as hygiene_comment,

Yson::ConvertToInt64(answer.data.answer_files_599323.question.id) as hygiene_files_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_files_599323.value), ($x) -> (Yson::ConvertToString($x.path))), ';')  as hygiene_files,

Yson::ConvertToInt64(answer.data.answer_choices_597287.question.id) as hygiene_rate_id,
Yson::ConvertToString(answer.data.answer_choices_597287.value[0].col.text) as hygiene_rate,
Yson::ConvertToString(answer.data.answer_choices_597287.value[0].col.key) as hygiene_rate_key,

Yson::ConvertToInt64(answer.data.answer_boolean_597225.question.id) as system_error_id,
Yson::ConvertToBool(answer.data.answer_boolean_597225.value) as system_error,
Yson::ConvertToString(answer.data.answer_boolean_597225.value.slug) as system_error_key,

Yson::ConvertToInt64(answer.data.answer_choices_607145.question.id) as critical_error_id,
Yson::ConvertToString(answer.data.answer_choices_607145.value[0].text) as critical_error,
Yson::ConvertToString(answer.data.answer_choices_607145.value[0].slug) as critical_error_key,


Yson::ConvertToInt64(answer.data.answer_choices_597329.question.id) as check_blocker_id,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597329.value), ($x) -> (Yson::ConvertToString($x.text))), ';')  as check_blocker,
String::JoinFromList(Listmap(Yson::ConvertToList(answer.data.answer_choices_597329.value), ($x) -> (Yson::ConvertToString($x.key))), ';')  as check_blocker_key,

Yson::ConvertToInt64(answer.data.answer_choices_597288.question.id) as quality_rate_id,
Yson::ConvertToString(answer.data.answer_choices_597288.value[0].col.text) as quality_rate,
Yson::ConvertToString(answer.data.answer_choices_597288.value[0].col.key) as quality_rate_key,

FROM `//home/forms/answers/forms_int/production/69181/data`



-- Исполнитель	answer_choices_597153       ок
-- ФИО оператора	answer_choices_597158       ок
-- ТЛ	answer_choices_627412           ok
-- Бригадир	answer_choices_627420       ok
-- Дата проверки	answer_date_597192    ok
-- Тип проверки	answer_choices_597209     ok
-- Сценарий	answer_choices_597162           ok
-- Ссылка на сделку CRM	answer_url_597285       ok
-- Оценка потенциала	answer_choices_599212   ok
-- Tier	answer_choices_599213                   ok
-- Воронка CRM	answer_choices_599200           ok
-- Этап CRM	answer_choices_599204               ok
-- Ссылка на звонок	answer_url_599205           ok
-- Длительность звонка	answer_number_599209    ok
-- Дата коммуникации	answer_date_597194      ok
-- Категории	answer_choices_597161           ok
-- Критерии: TOV	answer_choices_597289       ok
-- Интеграции T	answer_choices_674009           ok
-- Голосовая поддержка T	answer_choices_674110   ok
-- **Комментарий TOV**	answer_long_text_599318     ok
-- Дополнение к комментарию TOV	answer_files_599319 ok
-- **Оценка по шкале: TOV**	answer_choices_597168   ok
-- Критерии: Алгоритмы	answer_choices_597322       ok
-- Доп.договоры А	answer_choices_632085           ok
-- Массфикс А	answer_choices_634968               ok
-- Наложенный платеж А	answer_choices_638010       ok
-- Скоринг А	answer_choices_661607               ok
-- Голосовая поддержка А	answer_choices_674112           ok
-- **Комментарий Алгоритмы**	answer_long_text_599320         ok
-- Дополнение к комментарию Алгоритмы	answer_files_599322     ok
-- **Оценка  по шкале: Алгоритмы**	answer_choices_597286       ok
-- Критерии: Гигиена в CRM	answer_choices_597325               ok
-- Массфикс Г	answer_choices_634970                           ok
-- Скоринг Г	answer_choices_661625                           ok
-- Интеграции Г	answer_choices_674012                           ok
-- Голосовая поддержка Г	answer_choices_674113               ok
-- **Комментарий Гигиена**	answer_long_text_599321             ok
-- Дополнение к комментарию Гигиена	answer_files_599323         ok
-- **Оценка  по шкале: Гигиена**	answer_choices_597287       ok
-- Есть ошибка системы	answer_boolean_597225                   ok
-- Что мешает выполнить проверку?	answer_choices_597329       ok
-- **!!Есть критичные ошибки!!**	answer_choices_607145       ok
-- **Оценка  качества по шкале**	answer_choices_597288       ok
