use hahn;

$invoice = '//home/taxi-delivery/analytics/production/b2b/support/CORPINVOICE/issues';
$chatterbox = '//home/taxi-delivery/analytics/production/b2b/support/Chatterbox/both_lines_tickets';
$calls = '//home/taxi-delivery/analytics/production/b2b/support/call_center';
$telegram = '//home/taxi-delivery/analytics/production/b2b/support/CORPSUPPORTBOT/issues';
$save_to = '//home/taxi-delivery/analytics/production/b2b/support/support_dashboard_data';


-- drop table $save_to;
insert into $save_to with truncate
select
    'INVOICE' as origin,
    assignee_login as assignee_login,
    cast(assignee_uid as String) as assignee_uid,
    author_login as author_login,
    author_uid as author_uid,
    corp_client as corp_client,
    corp_contract as corp_contract,
    created_dttm_utc as created_dttm_utc,
    created_dttm_utc_formatted as created_dttm_utc_formatted,
    amount as amount,
    currency as currency,
    epic_flg as epic_flg,
    resolved_dttm_utc as resolved_dttm_utc,
    resolved_dttm_utc_formatted as resolved_dttm_utc_formatted,
    resolver_login as resolver_login,
    resolver_uid as resolver_uid,
    sla_first_spent_sec as sla_first_spent_sec,
    sla_first_violation_status as sla_first_violation_status,
    sla_payment_processing_spent_sec as sla_payment_processing_spent_sec,
    sla_payment_processing_violation_status as sla_payment_processing_violation_status,
    sla_request_complaint_spent_sec as sla_request_complaint_spent_sec,
    sla_request_complaint_violation_status as sla_request_complaint_violation_status,
    NULL as sla_reply_sec,
    NULL as sla_full_sec,
    NULL as sla_full_violation_status,
    status as status,
    NULL as theme,
    ticket_id as ticket_id,
    NULL as ticket_link,
    tier as tier,
    NULL as csat,
    NULL as csat_value,
    NULL as csat_value_5,
    NULL as autoreply_flg,
    NULL as category,
    NULL as chatterbox_ticket,
    NULL as city,
    NULL as country,
    NULL as line,
    NULL as line_type,
    NULL as meta_category,
    NULL as norm_timespent_sec,
    NULL as queue,
    NULL as reopens,
    NULL as sector,
    NULL as source,
    NULL as startrek_ticket,
    NULL as tariff,
    NULL as tariff_zone,
    NULL as total_timespent_sec,
    NULL as abonent_phone_id,
    NULL as agent_id,
    NULL as answered_at_dttm,
    NULL as answered_at_dttm_formatted,
    NULL as answered_to_completed_sec,
    NULL as call_guid,
    NULL as call_id,
    NULL as callcenter_id,
    NULL as called_number,
    NULL as completed_at_dttm,
    NULL as completed_at_dttm_formatted,
    NULL as queued_at_dttm,
    NULL as queued_at_dttm_formatted,
    NULL as queued_to_answered_sec,
    NULL as state,
    NULL as supervisor_login,
    NULL as timezone,
    NULL as transfered_to,
    NULL as working_domain,
    NULL as yandex_login
from
    $invoice

union all

select
    'TELEGRAM' as origin,
    assignee_login as assignee_login,
    cast(assignee_uid as String) as assignee_uid,
    author_login as author_login,
    author_uid as author_uid,
    corp_client as corp_client,
    NULL as corp_contract,
    created_dttm_utc as created_dttm_utc,
    created_dttm_utc_formatted as created_dttm_utc_formatted,
    NULL as amount,
    NULL as currency,
    NULL as epic_flg,
    resolved_dttm_utc as resolved_dttm_utc,
    resolved_dttm_utc_formatted as resolved_dttm_utc_formatted,
    resolver_login as resolver_login,
    resolver_uid as resolver_uid,
    sla_first_spent_sec as sla_first_spent_sec,
    sla_first_violation_status as sla_first_violation_status,
    NULL as sla_payment_processing_spent_sec,
    NULL as sla_payment_processing_violation_status,
    NULL as sla_request_complaint_spent_sec,
    NULL as sla_request_complaint_violation_status,
    NULL as sla_reply_sec,
    sla_full_spent_sec as sla_full_sec,
    sla_full_violation_status as sla_full_violation_status,
    status as status,
    theme as theme,
    ticket_id as ticket_id,
    NULL as ticket_link,
    NULL as tier,
    cast(csat as Float) as csat,
    NULL as csat_value,
    NULL as csat_value_5,
    NULL as autoreply_flg,
    NULL as category,
    NULL as chatterbox_ticket,
    NULL as city,
    NULL as country,
    NULL as line,
    NULL as line_type,
    NULL as meta_category,
    NULL as norm_timespent_sec,
    NULL as queue,
    NULL as reopens,
    NULL as sector,
    NULL as source,
    NULL as startrek_ticket,
    NULL as tariff,
    NULL as tariff_zone,
    NULL as total_timespent_sec,
    NULL as abonent_phone_id,
    NULL as agent_id,
    NULL as answered_at_dttm,
    NULL as answered_at_dttm_formatted,
    NULL as answered_to_completed_sec,
    NULL as call_guid,
    NULL as call_id,
    NULL as callcenter_id,
    NULL as called_number,
    NULL as completed_at_dttm,
    NULL as completed_at_dttm_formatted,
    NULL as queued_at_dttm,
    NULL as queued_at_dttm_formatted,
    NULL as queued_to_answered_sec,
    NULL as state,
    NULL as supervisor_login,
    NULL as timezone,
    NULL as transfered_to,
    NULL as working_domain,
    NULL as yandex_login
from
    $telegram

union all

select
    'CHATTERBOX' as origin,
    cast(assignee_id as String) as assignee_login,
    cast(assignee_id as String) as assignee_uid,
    NULL as author_login,
    NULL as author_uid,
    NULL as corp_client,
    NULL as corp_contract,
    creation_dttm_utc as created_dttm_utc,
    creation_dttm_utc_formatted as created_dttm_utc_formatted,
    NULL as amount,
    NULL as currency,
    NULL as epic_flg,
    solved_dttm_utc as resolved_dttm_utc,
    solved_dttm_utc_formatted as resolved_dttm_utc_formatted,
    NULL as resolver_login,
    NULL as resolver_uid,
    NULL as sla_first_spent_sec,
    NULL as sla_first_violation_status,
    NULL as sla_payment_processing_spent_sec,
    NULL as sla_payment_processing_violation_status,
    NULL as sla_request_complaint_spent_sec,
    NULL as sla_request_complaint_violation_status,
    sla_reply_sec as sla_reply_sec,
    sla_full_sec as sla_full_sec,
    NULL as sla_full_violation_status,
    status as status,
    theme as theme,
    ticket_id as ticket_id,
    ticket_link as ticket_link,
    NULL as tier,
    cast(csat as Float) as csat,
    csat_value as csat_value,
    csat_value_5 as csat_value_5,
    autoreply_flg as autoreply_flg,
    category as category,
    chatterbox_ticket as chatterbox_ticket,
    city as city,
    country as country,
    line as line,
    line_type as line_type,
    meta_category as meta_category,
    norm_timespent_sec as norm_timespent_sec,
    queue as queue,
    reopens as reopens,
    sector as sector,
    source as source,
    startrek_ticket as startrek_ticket,
    tariff as tariff,
    tariff_zone as tariff_zone,
    total_timespent_sec as total_timespent_sec,
    NULL as abonent_phone_id,
    NULL as agent_id,
    NULL as answered_at_dttm,
    NULL as answered_at_dttm_formatted,
    NULL as answered_to_completed_sec,
    NULL as call_guid,
    NULL as call_id,
    NULL as callcenter_id,
    NULL as called_number,
    NULL as completed_at_dttm,
    NULL as completed_at_dttm_formatted,
    NULL as queued_at_dttm,
    NULL as queued_at_dttm_formatted,
    NULL as queued_to_answered_sec,
    NULL as state,
    NULL as supervisor_login,
    NULL as timezone,
    NULL as transfered_to,
    NULL as working_domain,
    NULL as yandex_login
from
    $chatterbox

union all

select
    'CALLS' as origin,
    staff_login as assignee_login,
    NULL as assignee_uid,
    NULL as author_login,
    NULL as author_uid,
    NULL as corp_client,
    NULL as corp_contract,
    created_dttm as created_dttm_utc,
    created_dttm_formatted as created_dttm_utc_formatted,
    NULL as amount,
    NULL as currency,
    NULL as epic_flg,
    NULL as resolved_dttm_utc,
    NULL as resolved_dttm_utc_formatted,
    NULL as resolver_login,
    NULL as resolver_uid,
    NULL as sla_first_spent_sec,
    NULL as sla_first_violation_status,
    NULL as sla_payment_processing_spent_sec,
    NULL as sla_payment_processing_violation_status,
    NULL as sla_request_complaint_spent_sec,
    NULL as sla_request_complaint_violation_status,
    NULL as sla_reply_sec,
    NULL as sla_full_sec,
    NULL as sla_full_violation_status,
    endreason as status,
    NULL as theme,
    NULL as ticket_id,
    NULL as ticket_link,
    NULL as tier,
    NULL as csat,
    NULL as csat_value,
    NULL as csat_value_5,
    NULL as autoreply_flg,
    NULL as category,
    NULL as chatterbox_ticket,
    NULL as city,
    NULL as country,
    NULL as line,
    NULL as line_type,
    NULL as meta_category,
    NULL as norm_timespent_sec,
    queue as queue,
    NULL as reopens,
    NULL as sector,
    NULL as source,
    NULL as startrek_ticket,
    NULL as tariff,
    NULL as tariff_zone,
    NULL as total_timespent_sec,
    abonent_phone_id as abonent_phone_id,
    agent_id as agent_id,
    answered_at_dttm as answered_at_dttm,
    answered_at_dttm_formatted as answered_at_dttm_formatted,
    answered_to_completed_sec as answered_to_completed_sec,
    call_guid as call_guid,
    call_id as call_id,
    callcenter_id as callcenter_id,
    called_number as called_number,
    completed_at_dttm as completed_at_dttm,
    completed_at_dttm_formatted as completed_at_dttm_formatted,
    queued_at_dttm as queued_at_dttm,
    queued_at_dttm_formatted as queued_at_dttm_formatted,
    queued_to_answered_sec as queued_to_answered_sec,
    state as state,
    supervisor_login as supervisor_login,
    timezone as timezone,
    transfered_to as transfered_to,
    working_domain as working_domain,
    yandex_login as yandex_login
from
    $calls
;
