/*
    Автор: @ikhomyanin

    Использование:
    Скрипт используется в задаче на довыплату денег исполнителям Грузового, которые развозят last mile Маркета.
    Причем здесь выгружаются смены, которые есть в данных Маркета, но их нет в данных Доставки

    Тикет: LOGDATA-774
*/

use hahn;
pragma SimpleColumns;

$today = CurrentUtcDate();
$start_of_week = DateTime::MakeDate(DateTime::StartOfWeek($today));

$date_from = cast($start_of_week - 7*Interval('P1D') as String);
$date_to = cast($start_of_week - Interval('P1D') as String); -- включительно

$table_path = '//home/taxi-delivery/analytics/production/cargo/b2b/market_payments/' || $date_from || '_' || $date_to;

SELECT courier_name
    , dostavlyaemost
    , id_cou
    , lockerCount_billing
    , multiOrdersStandardCount_billing
    , pvzCount_billing
    , shift_date
    , sorting_center_name
    , total_multi_billing
    , transitDistance_billing
    , transport_type
    , user_shift_id
from $table_path
where driver_id is null;