-- https://st.yandex-team.ru/LOGDATA-541
-- ДЛЯ РУЧНИКА

use hahn;

$CLAIMS = '//home/taxi/production/replica/postgres/cargo_claims/claims';
$CLAIM_POINTS = '//home/taxi/production/replica/postgres/cargo_claims/claim_points';
$POINTS = '//home/taxi/production/replica/postgres/cargo_claims/points';
$ADDITIONAL_INFO = '//home/taxi/production/replica/postgres/cargo_claims/additional_info';

$PROCESSED_CLAIMS = '//home/taxi-delivery/analytics/production/cargo/b2b/manual_dispatch/processed_claims';

$SAVE_TO = '//home/taxi-delivery/analytics/production/cargo/b2b/manual_dispatch/new_claims';

-- $LP_CORP_ID = ''; -- ЖДУ ЭМИЛЯ
$MARKET_ID = 'dca7971b1b62480cbb9441f165e73080';

$MIN_SEC = 1633824000; -- Sun Oct 10 2021 03:00:00 GMT+0300 (Moscow Standard Time)

$current_sec = DateTime::ToSeconds(CurrentUtcDatetime());

-- $MARKET_POINTS = [
--     '2-я Мелитопольская улица, вл10Ас13 Москва, Россия' -- СЦ Юг / СЦ "ПЭК" Бутово 
--     , 'Россия, Москва, 2-я Мелитопольская улица, вл10Ас13' -- СЦ Юг / СЦ "ПЭК" Бутово 
--     , '4-я Кабельная улица, 6А Москва, Россия' -- СЦ Восток
--     , 'Гвардейская улица, 55А Казань, Республика Татарстан, Россия' -- СЦ Казань
--     , 'Дмитровское шоссе, 157с12 Москва, Россия' -- СЦ Север
--     , 'Железнодорожная улица, 97/99 Саратов, Россия' -- СЦ МК Саратов
--     , 'Магнитогорская улица, 21к1 Санкт-Петербург, Россия' -- СЦ Питер
--     , 'Новомосковское шоссе, 54 Тула, Россия, 300045' -- СЦ МК Тула
--     , 'Россия, Самара, Железнодорожный район, Верхне-Карьерная улица, 3А' -- СЦ МК Самара
--     , 'Рябиновая улица, 53с2 Москва, Россия' -- СЦ МК Запад
--     , 'Чкалова, 38 ст3, Центральный Промузел, Железнодорожный округ, Рязань' -- СЦ МК Рязань
--     , 'проспект Фрунзе, 97, Ярославль, Россия' -- СЦ МК Ярославль
--     , 'улица 50 лет Октября, 126 Курск, Россия, 305040' -- СЦ МК Курск
--     , 'улица Вишняковой, 7/1 микрорайон Черёмушки, Центральный округ, Краснодар, Россия' -- СЦ Краснодар
--     , 'улица Логопарк, 2к2 Аксайский район, Ростовская область, Россия' -- СЦ Ростов

--     , 'улица Менделеева, 134/4А Уфа, Республика Башкортостан, Россия, 450022' -- СЦ МК Уфа
--     , 'улица Менделеева, 134Е, Уфа, Республика Башкортостан, Россия' -- СЦ МК Уфа

--     , 'микрорайон Птицефабрика, к8 рабочий посёлок Томилино, городской округ Люберцы, Московская область, Россия' -- СЦ Томилино
--     , 'Россия, Московская область, городской округ Люберцы, рабочий посёлок Томилино, Новорязанское шоссе, 23-й километр, 27'
--     , 'Россия, Московская область, городской округ Люберцы, рабочий посёлок Томилино, микрорайон Птицефабрика, к8'

--     , 'улица Горького, 91к6, село Цемдолина, Новороссийск, Краснодарский край, Россия' -- СЦ МК Новороссийск
-- ];

$MARKET_POINT_COORDS = [
    (55.006609, 82.643769) -- S7
];

$processed_claims_data = (
    select claim_uuid
    from $PROCESSED_CLAIMS
);

-- $logistic_platform_claims = (
--     select c.id as claim_id
--         , c.uuid_id as claim_uuid
--         , c.due as claim_due
--         , p.longitude as point_longitude
--         , p.latitude as point_latitude
--         , p.fullname as point_fullname
--         , c.corp_client_id as corp_client_id
--         , c.created_ts as claim_created_ts
--         , c.status as claim_status
--     from $CLAIMS as c
--     left join $CLAIM_POINTS as cp on c.id=cp.claim_id
--     left join $POINTS as p on cp.point_id=p.id
--     left join $ADDITIONAL_INFO as ai on c.id=ai.claim_id
--     where c.corp_client_id = $LP_CORP_ID
--         and cp.type='source'
--         and (ai.taxi_class!='express' and ai.taxi_class!='courier')
--         and c.uuid_id not in $processed_claims_data
--         and c.created_ts >= $MIN_SEC
--         -- and c.claim_status='new'
-- );

$market_claims = (
    select c.id as claim_id
        , c.uuid_id as claim_uuid
        , c.due as claim_due
        , p.longitude as point_longitude
        , p.latitude as point_latitude
        , p.fullname as point_fullname
        , c.corp_client_id as corp_client_id
        , c.created_ts as claim_created_ts
        , c.status as claim_status
    from $CLAIMS as c 
    left join $CLAIM_POINTS as cp on c.id=cp.claim_id
    left join $POINTS as p on cp.point_id=p.id
    left join $ADDITIONAL_INFO as ai on c.id=ai.claim_id
    where c.corp_client_id = $MARKET_ID
        and cp.type='source'
        -- and p.fullname in $MARKET_POINTS
        and (p.latitude, p.longitude) in $MARKET_POINT_COORDS
        -- and (ai.taxi_class!='express' and ai.taxi_class!='courier')
        and c.uuid_id not in $processed_claims_data
        and c.created_ts >= $MIN_SEC
        and c.due > $current_sec
        -- and c.claim_status='new'
);

insert into $SAVE_TO with truncate
-- select * from $logistic_platform_claims
-- union all
select * from $market_claims;
