use chyt.hahn/taxi-delivery;


--create table "//home/taxi-delivery/analytics/dev/ndd/market_courier_delivery_2h_dl" engine=YtTable() as 
insert into "<append=false>//home/taxi-delivery/analytics/dev/ndd/market_courier_delivery_2h_dl"
SELECT
    `balance_payment_id`,
    `barcode`,
   
    `created`,
    `credentials_address`,
    `credentials_email`,
    `credentials_extra`,
    `credentials_incorporation`,
    `credentials_inn`,
    `credentials_legal_form`,
    `credentials_name`,

    `credentials_url`,
    `delivery_date_max`,
    `delivery_date_min`,
    `delivery_end_time`,
    `delivery_interval_id`,
    `delivery_interval_tz_offset`,
    `delivery_start_time`,
    `delivery_type`,
    `external_id`,
    `fake`,
    `id`,
    `market_id_from`,
    `max_absent_items_price_percent`,
    `pickup_point_building`,
    `pickup_point_country`,
    `pickup_point_district`,
    `pickup_point_external_id`,
    `recipient_district`,
    `recipient_email`,
    `recipient_intercom`,
    `recipient_last_name`,
    `recipient_locality`,
    `recipient_metro`,
    `recipient_middle_name`,
    `recipient_porch`,
    `recipient_region`,
    `recipient_room`,
    `recipient_settlement`,
    `recipient_street`,
    `recipient_sub_region`,
    `recipient_uid`,
    `recipient_verification_code`,
    `recipient_zip_code`,
    `return_registry_id`,
    `return_sorting_center_id`,
    `sender_balance_client_id`,
    `sender_balance_product_id`,
    `sender_emails`,
    `sender_first_name`,
    `sender_id`,
    `sender_last_name`,
    `sender_middle_name`,
    `sender_name`,
    `sender_phone_number`,
    if(`sla.cp110_datetime` in ('1970-01-01T00:00:00', '2100-01-01T00:00:00'), null, `sla.cp110_datetime`) as `sla.cp110_datetime`,
    `sla.cp48_datetime`,
    --`sla.delivery_method`,
    --`sla.delivery_timeliness`,
    toDateTime(if(`sla.fact_delivery_datetime` in ('1970-01-01T00:00:00', '2100-01-01T00:00:00') , null, `sla.fact_delivery_datetime`)) as delivered_dttm,
    if(delivered_dttm is not null, request_code, null) as delivered_id,
    --`sla.order_has_update_by_recipient_flag`,
    `sla.order_logistic_status`,
    toDateTime(if(`sla.original_delivery_from_datetime` in ('1970-01-01T00:00:00', '2100-01-01T00:00:00'), null, `sla.original_delivery_from_datetime`)) as `sla.original_delivery_from_datetime`,
    toDateTime(if(`sla.original_delivery_to_datetime` in ('1970-01-01T00:00:00', '2100-01-01T00:00:00'), null, `sla.original_delivery_to_datetime`)) as `sla.original_delivery_to_datetime`,
    --`sla.shipment_from_shop_timeliness`,
    --`sla.shipment_to_delivery_service_timeliness`,
    `source_id`,
    `status`,
    `updated`,
    `validation_error`,
    `version`, 
    employer_code, payment_method, operator_id, request_code,
    argMax(timestamp_add(toDateTime(left(new_delivery_date_time_from, 19)), Interval toInt64(left(substr(new_delivery_date_time_from, 21,22), 2)) hour), date_changed_at) as new_delivery_date_time_from,
    argMax(timestamp_add(toDateTime(left(new_delivery_date_time_to, 19)), Interval toInt64(left(substr(new_delivery_date_time_to, 21,22), 2)) hour), date_changed_at) as new_delivery_date_time_to,
    MAX(date_changed_at) as date_changed_at_max,
    argMax(reason, date_changed_at) as reason,
    MAX(if("canc.tracker_status" <> 'RETURN_PREPARING',"canc.tracker_status", null))  as tracker_status,

    MAX(toDate("canc.cancelled_datetime")) as cancelled_datetime,
    status_dttm_NOT_CALLED,
    status_dttm_FAILED,
    status_dttm_SUCCESS,
    status_dttm_CLOSED,
    status_dttm_RECALL_REQUIRED,
    status_dttm_SUCCESS_CLIENT_CONFIRM,
    status_dttm_CLIENT_ASK_NOT_TO_CALL,
    Max(cancel_reason) as cancel_reason,
    MAX(sort_center_cancelled_dttm) as sort_center_cancelled_dttm,
    MAX(tpl_context) as tpl_context,
    MAX(tpl_source) as tpl_source,
    MAX(tpl_type) as tpl_type,
    MAX(tpl_dttm) as tpl_dttm,
    MAX(canc_dttm) as canc_dttm,
    MAX(canc_context) as canc_context,
    MAX(resc_context) as resc_context,
    MAX(resc_dttm) as resc_dttm,
    MAX(ad_context) as ad_context,
    MAX(ad_dttm) as ad_dttm,
    MAX(post_context) as post_context,
    MAX(post_dttm) as post_dttm
--FROM `//home/taxi-delivery/analytics/dev/ndd/market_courier_delivery`

FROM `//home/taxi-delivery/analytics/dev/ndd/market_courier_delivery_2h`

group by 
    `balance_payment_id`,
    `barcode`,
    --cancel_reason,
    `created`,
    `credentials_address`,
    `credentials_email`,
    `credentials_extra`,
    `credentials_incorporation`,
    `credentials_inn`,
    `credentials_legal_form`,
    `credentials_name`,

    `credentials_url`,
    `delivery_date_max`,
    `delivery_date_min`,
    `delivery_end_time`,
    `delivery_interval_id`,
    `delivery_interval_tz_offset`,
    `delivery_start_time`,
    `delivery_type`,
    `external_id`,
    `fake`,
    `id`,
    `market_id_from`,
    `max_absent_items_price_percent`,
    `pickup_point_building`,
    `pickup_point_country`,
    `pickup_point_district`,
    `pickup_point_external_id`,
    `recipient_district`,
    `recipient_email`,
    `recipient_intercom`,
    `recipient_last_name`,
    `recipient_locality`,
    `recipient_metro`,
    `recipient_middle_name`,
    `recipient_porch`,
    `recipient_region`,
    `recipient_room`,
    `recipient_settlement`,
    `recipient_street`,
    `recipient_sub_region`,
    `recipient_uid`,
    `recipient_verification_code`,
    `recipient_zip_code`,
    `return_registry_id`,
    `return_sorting_center_id`,
    `sender_balance_client_id`,
    `sender_balance_product_id`,
    `sender_emails`,
    `sender_first_name`,
    `sender_id`,
    `sender_last_name`,
    `sender_middle_name`,
    `sender_name`,
    `sender_phone_number`,
    `sla.cp110_datetime`,
    `sla.cp48_datetime`,
    --`sla.delivery_method`,
    --`sla.delivery_timeliness`,
    delivered_dttm,
    delivered_id,
    --`sla.order_has_update_by_recipient_flag`,
    `sla.order_logistic_status`,
    `sla.original_delivery_from_datetime`,
    `sla.original_delivery_to_datetime`,
    --`sla.shipment_from_shop_timeliness`,
    --`sla.shipment_to_delivery_service_timeliness`,
    `source_id`,
    `status`,
    `updated`,
    `validation_error`,
    `version`, 
    employer_code, payment_method, operator_id, request_code,
   -- new_delivery_date_time_from,
   -- new_delivery_date_time_to,
    --date_changed_at,
    --reason, 

   -- cancelled_datetime,
    status_dttm_NOT_CALLED,
    status_dttm_FAILED,
    status_dttm_SUCCESS,
    status_dttm_CLOSED,
    status_dttm_RECALL_REQUIRED,
    status_dttm_SUCCESS_CLIENT_CONFIRM,
    status_dttm_CLIENT_ASK_NOT_TO_CALL

