import argparse
# import time

import datetime

from projects.efficiency_metrics.manager import Manager
from projects.efficiency_metrics.project_config import get_project_cluster

from nile.api.v1 import extractors as ne
from nile.api.v1 import filters as nf

from projects.data_sources.data_context.eda_logs import \
    DataContext as EdaOrdersDataContext
from projects.data_sources.data_context.raw_services_logs import \
    DataContext as RawLogs

from projects.data_sources.data_context.cargo import \
    DataContext as CargoLogsDataContext
import time

from nile.api.v1 import filters as nf

import geohash as gh

# TODO: 1. what is it - burning in geohash/geozone and how to transfer it to ml-model
# TODO: 2. target for ml model (due; express/courier-fallback)
# TODO: 3. (utilizaton, burning) in geohash/geozone
# TODO: candidates-checking
# ---
# LD
# TODO: moscow/vkusvill ??
# TODO: c2c, b2b

if __name__ == '__main__':

    parser = argparse.ArgumentParser()
    parser.add_argument('--yt-proxy', type=str, default='Hahn')

    cluster = get_project_cluster()
    import yt.wrapper as yt
    import datetime

    yt.config.set_proxy("hahn")

    print(yt.VERSION)

    from_date = '2021-04-10'
    to_date = '2021-04-17'

    # min_incremental_key = 260460746
    # min_incremental_key = 1618908497
    #
    # min_incremental_key = 17601315
    #
    # table_name =
    # table_name = '//home/taxi/production/replica/postgres/cargo_claims/claims'

    job = cluster.job('Couriers collection' + str(time.time()))
    job = job.env(bytes_decode_mode='strict')
                  #, yt_spec_defaults={'max_failed_job_count': 1000})

    cargo_d_c = CargoLogsDataContext(
        job,
        datetime.datetime.strptime(
            from_date, '%Y-%m-%d')
        ,
        datetime.datetime.strptime(
            to_date, '%Y-%m-%d'
        ),
    )

    claims = cargo_d_c.get_claim_audit()



    job.run()

    # "old_status"
    # "new_status"
    # "claim_id"
    # "event_time"
    # "comment"
    # "ticket"
    # "old_current_point"
    # "new_current_point"
    # rows = yt.select_rows(
    #     '* FROM [' +
    #     table_name +
    #     '] WHERE id > {min_incremental_key} '.format(
    #         min_incremental_key=min_incremental_key)
    # )

    # rows = yt.select_rows(
    #     '* FROM [' +
    #     table_name +
    #     '] WHERE id > {min_incremental_key} '.format(
    #         min_incremental_key=min_incremental_key)
    # )
    #
    # for row in rows[:10]:
    #     print(row)
    # print (len(rows))
